# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['GroupSchemaPropertyArgs', 'GroupSchemaProperty']

@pulumi.input_type
class GroupSchemaPropertyArgs:
    def __init__(__self__, *,
                 index: pulumi.Input[builtins.str],
                 title: pulumi.Input[builtins.str],
                 type: pulumi.Input[builtins.str],
                 array_enums: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 array_one_ofs: Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyArrayOneOfArgs']]]] = None,
                 array_type: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 enums: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 external_name: Optional[pulumi.Input[builtins.str]] = None,
                 external_namespace: Optional[pulumi.Input[builtins.str]] = None,
                 master: Optional[pulumi.Input[builtins.str]] = None,
                 master_override_priorities: Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyMasterOverridePriorityArgs']]]] = None,
                 max_length: Optional[pulumi.Input[builtins.int]] = None,
                 min_length: Optional[pulumi.Input[builtins.int]] = None,
                 one_ofs: Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyOneOfArgs']]]] = None,
                 permissions: Optional[pulumi.Input[builtins.str]] = None,
                 required: Optional[pulumi.Input[builtins.bool]] = None,
                 scope: Optional[pulumi.Input[builtins.str]] = None,
                 unique: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a GroupSchemaProperty resource.
        :param pulumi.Input[builtins.str] index: Subschema unique string identifier
        :param pulumi.Input[builtins.str] title: Subschema title (display name)
        :param pulumi.Input[builtins.str] type: The type of the schema property. It can be `string`, `boolean`, `number`, `integer`, `array`, or `object`
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] array_enums: Array of values that an array property's items can be set to.
        :param pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyArrayOneOfArgs']]] array_one_ofs: Display name and value an enum array can be set to. - 'const' - (Required) value mapping to member of 'enum'. - 'title'
               - (Required) display name for the enum value.
        :param pulumi.Input[builtins.str] array_type: The type of the array elements if `type` is set to `array`
        :param pulumi.Input[builtins.str] description: The description of the user schema property.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] enums: Array of values a primitive property can be set to. See `array_enum` for arrays.
        :param pulumi.Input[builtins.str] external_name: External name of the user schema property.
        :param pulumi.Input[builtins.str] external_namespace: External namespace of the user schema property.
        :param pulumi.Input[builtins.str] master: Master priority for the group schema property. It can be set to `PROFILE_MASTER`, `OVERRIDE` or `OKTA`. Default:
               `PROFILE_MASTER`
        :param pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyMasterOverridePriorityArgs']]] master_override_priorities: Prioritized list of profile sources (required when `master` is `OVERRIDE`).
        :param pulumi.Input[builtins.int] max_length: The maximum length of the user property value. Only applies to type `string`
        :param pulumi.Input[builtins.int] min_length: The minimum length of the user property value. Only applies to type `string`
        :param pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyOneOfArgs']]] one_ofs: Array of maps containing a mapping for display name to enum value. - 'const' - (Required) value mapping to member of
               'enum'. - 'title' - (Required) display name for the enum value.
        :param pulumi.Input[builtins.str] permissions: Access control permissions for the property. It can be set to `READ_WRITE`, `READ_ONLY`, `HIDE`. Default: `READ_ONLY`
        :param pulumi.Input[builtins.bool] required: Whether the subschema is required
        :param pulumi.Input[builtins.str] unique: Whether the property should be unique. It can be set to `UNIQUE_VALIDATED` or `NOT_UNIQUE`.
        """
        pulumi.set(__self__, "index", index)
        pulumi.set(__self__, "title", title)
        pulumi.set(__self__, "type", type)
        if array_enums is not None:
            pulumi.set(__self__, "array_enums", array_enums)
        if array_one_ofs is not None:
            pulumi.set(__self__, "array_one_ofs", array_one_ofs)
        if array_type is not None:
            pulumi.set(__self__, "array_type", array_type)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if enums is not None:
            pulumi.set(__self__, "enums", enums)
        if external_name is not None:
            pulumi.set(__self__, "external_name", external_name)
        if external_namespace is not None:
            pulumi.set(__self__, "external_namespace", external_namespace)
        if master is not None:
            pulumi.set(__self__, "master", master)
        if master_override_priorities is not None:
            pulumi.set(__self__, "master_override_priorities", master_override_priorities)
        if max_length is not None:
            pulumi.set(__self__, "max_length", max_length)
        if min_length is not None:
            pulumi.set(__self__, "min_length", min_length)
        if one_ofs is not None:
            pulumi.set(__self__, "one_ofs", one_ofs)
        if permissions is not None:
            pulumi.set(__self__, "permissions", permissions)
        if required is not None:
            pulumi.set(__self__, "required", required)
        if scope is not None:
            pulumi.set(__self__, "scope", scope)
        if unique is not None:
            pulumi.set(__self__, "unique", unique)

    @property
    @pulumi.getter
    def index(self) -> pulumi.Input[builtins.str]:
        """
        Subschema unique string identifier
        """
        return pulumi.get(self, "index")

    @index.setter
    def index(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "index", value)

    @property
    @pulumi.getter
    def title(self) -> pulumi.Input[builtins.str]:
        """
        Subschema title (display name)
        """
        return pulumi.get(self, "title")

    @title.setter
    def title(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "title", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[builtins.str]:
        """
        The type of the schema property. It can be `string`, `boolean`, `number`, `integer`, `array`, or `object`
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="arrayEnums")
    def array_enums(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        Array of values that an array property's items can be set to.
        """
        return pulumi.get(self, "array_enums")

    @array_enums.setter
    def array_enums(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "array_enums", value)

    @property
    @pulumi.getter(name="arrayOneOfs")
    def array_one_ofs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyArrayOneOfArgs']]]]:
        """
        Display name and value an enum array can be set to. - 'const' - (Required) value mapping to member of 'enum'. - 'title'
        - (Required) display name for the enum value.
        """
        return pulumi.get(self, "array_one_ofs")

    @array_one_ofs.setter
    def array_one_ofs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyArrayOneOfArgs']]]]):
        pulumi.set(self, "array_one_ofs", value)

    @property
    @pulumi.getter(name="arrayType")
    def array_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The type of the array elements if `type` is set to `array`
        """
        return pulumi.get(self, "array_type")

    @array_type.setter
    def array_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "array_type", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The description of the user schema property.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def enums(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        Array of values a primitive property can be set to. See `array_enum` for arrays.
        """
        return pulumi.get(self, "enums")

    @enums.setter
    def enums(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "enums", value)

    @property
    @pulumi.getter(name="externalName")
    def external_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        External name of the user schema property.
        """
        return pulumi.get(self, "external_name")

    @external_name.setter
    def external_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "external_name", value)

    @property
    @pulumi.getter(name="externalNamespace")
    def external_namespace(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        External namespace of the user schema property.
        """
        return pulumi.get(self, "external_namespace")

    @external_namespace.setter
    def external_namespace(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "external_namespace", value)

    @property
    @pulumi.getter
    def master(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Master priority for the group schema property. It can be set to `PROFILE_MASTER`, `OVERRIDE` or `OKTA`. Default:
        `PROFILE_MASTER`
        """
        return pulumi.get(self, "master")

    @master.setter
    def master(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "master", value)

    @property
    @pulumi.getter(name="masterOverridePriorities")
    def master_override_priorities(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyMasterOverridePriorityArgs']]]]:
        """
        Prioritized list of profile sources (required when `master` is `OVERRIDE`).
        """
        return pulumi.get(self, "master_override_priorities")

    @master_override_priorities.setter
    def master_override_priorities(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyMasterOverridePriorityArgs']]]]):
        pulumi.set(self, "master_override_priorities", value)

    @property
    @pulumi.getter(name="maxLength")
    def max_length(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The maximum length of the user property value. Only applies to type `string`
        """
        return pulumi.get(self, "max_length")

    @max_length.setter
    def max_length(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "max_length", value)

    @property
    @pulumi.getter(name="minLength")
    def min_length(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The minimum length of the user property value. Only applies to type `string`
        """
        return pulumi.get(self, "min_length")

    @min_length.setter
    def min_length(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "min_length", value)

    @property
    @pulumi.getter(name="oneOfs")
    def one_ofs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyOneOfArgs']]]]:
        """
        Array of maps containing a mapping for display name to enum value. - 'const' - (Required) value mapping to member of
        'enum'. - 'title' - (Required) display name for the enum value.
        """
        return pulumi.get(self, "one_ofs")

    @one_ofs.setter
    def one_ofs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyOneOfArgs']]]]):
        pulumi.set(self, "one_ofs", value)

    @property
    @pulumi.getter
    def permissions(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Access control permissions for the property. It can be set to `READ_WRITE`, `READ_ONLY`, `HIDE`. Default: `READ_ONLY`
        """
        return pulumi.get(self, "permissions")

    @permissions.setter
    def permissions(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "permissions", value)

    @property
    @pulumi.getter
    def required(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether the subschema is required
        """
        return pulumi.get(self, "required")

    @required.setter
    def required(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "required", value)

    @property
    @pulumi.getter
    def scope(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "scope")

    @scope.setter
    def scope(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "scope", value)

    @property
    @pulumi.getter
    def unique(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Whether the property should be unique. It can be set to `UNIQUE_VALIDATED` or `NOT_UNIQUE`.
        """
        return pulumi.get(self, "unique")

    @unique.setter
    def unique(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "unique", value)


@pulumi.input_type
class _GroupSchemaPropertyState:
    def __init__(__self__, *,
                 array_enums: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 array_one_ofs: Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyArrayOneOfArgs']]]] = None,
                 array_type: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 enums: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 external_name: Optional[pulumi.Input[builtins.str]] = None,
                 external_namespace: Optional[pulumi.Input[builtins.str]] = None,
                 index: Optional[pulumi.Input[builtins.str]] = None,
                 master: Optional[pulumi.Input[builtins.str]] = None,
                 master_override_priorities: Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyMasterOverridePriorityArgs']]]] = None,
                 max_length: Optional[pulumi.Input[builtins.int]] = None,
                 min_length: Optional[pulumi.Input[builtins.int]] = None,
                 one_ofs: Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyOneOfArgs']]]] = None,
                 permissions: Optional[pulumi.Input[builtins.str]] = None,
                 required: Optional[pulumi.Input[builtins.bool]] = None,
                 scope: Optional[pulumi.Input[builtins.str]] = None,
                 title: Optional[pulumi.Input[builtins.str]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None,
                 unique: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering GroupSchemaProperty resources.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] array_enums: Array of values that an array property's items can be set to.
        :param pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyArrayOneOfArgs']]] array_one_ofs: Display name and value an enum array can be set to. - 'const' - (Required) value mapping to member of 'enum'. - 'title'
               - (Required) display name for the enum value.
        :param pulumi.Input[builtins.str] array_type: The type of the array elements if `type` is set to `array`
        :param pulumi.Input[builtins.str] description: The description of the user schema property.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] enums: Array of values a primitive property can be set to. See `array_enum` for arrays.
        :param pulumi.Input[builtins.str] external_name: External name of the user schema property.
        :param pulumi.Input[builtins.str] external_namespace: External namespace of the user schema property.
        :param pulumi.Input[builtins.str] index: Subschema unique string identifier
        :param pulumi.Input[builtins.str] master: Master priority for the group schema property. It can be set to `PROFILE_MASTER`, `OVERRIDE` or `OKTA`. Default:
               `PROFILE_MASTER`
        :param pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyMasterOverridePriorityArgs']]] master_override_priorities: Prioritized list of profile sources (required when `master` is `OVERRIDE`).
        :param pulumi.Input[builtins.int] max_length: The maximum length of the user property value. Only applies to type `string`
        :param pulumi.Input[builtins.int] min_length: The minimum length of the user property value. Only applies to type `string`
        :param pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyOneOfArgs']]] one_ofs: Array of maps containing a mapping for display name to enum value. - 'const' - (Required) value mapping to member of
               'enum'. - 'title' - (Required) display name for the enum value.
        :param pulumi.Input[builtins.str] permissions: Access control permissions for the property. It can be set to `READ_WRITE`, `READ_ONLY`, `HIDE`. Default: `READ_ONLY`
        :param pulumi.Input[builtins.bool] required: Whether the subschema is required
        :param pulumi.Input[builtins.str] title: Subschema title (display name)
        :param pulumi.Input[builtins.str] type: The type of the schema property. It can be `string`, `boolean`, `number`, `integer`, `array`, or `object`
        :param pulumi.Input[builtins.str] unique: Whether the property should be unique. It can be set to `UNIQUE_VALIDATED` or `NOT_UNIQUE`.
        """
        if array_enums is not None:
            pulumi.set(__self__, "array_enums", array_enums)
        if array_one_ofs is not None:
            pulumi.set(__self__, "array_one_ofs", array_one_ofs)
        if array_type is not None:
            pulumi.set(__self__, "array_type", array_type)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if enums is not None:
            pulumi.set(__self__, "enums", enums)
        if external_name is not None:
            pulumi.set(__self__, "external_name", external_name)
        if external_namespace is not None:
            pulumi.set(__self__, "external_namespace", external_namespace)
        if index is not None:
            pulumi.set(__self__, "index", index)
        if master is not None:
            pulumi.set(__self__, "master", master)
        if master_override_priorities is not None:
            pulumi.set(__self__, "master_override_priorities", master_override_priorities)
        if max_length is not None:
            pulumi.set(__self__, "max_length", max_length)
        if min_length is not None:
            pulumi.set(__self__, "min_length", min_length)
        if one_ofs is not None:
            pulumi.set(__self__, "one_ofs", one_ofs)
        if permissions is not None:
            pulumi.set(__self__, "permissions", permissions)
        if required is not None:
            pulumi.set(__self__, "required", required)
        if scope is not None:
            pulumi.set(__self__, "scope", scope)
        if title is not None:
            pulumi.set(__self__, "title", title)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if unique is not None:
            pulumi.set(__self__, "unique", unique)

    @property
    @pulumi.getter(name="arrayEnums")
    def array_enums(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        Array of values that an array property's items can be set to.
        """
        return pulumi.get(self, "array_enums")

    @array_enums.setter
    def array_enums(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "array_enums", value)

    @property
    @pulumi.getter(name="arrayOneOfs")
    def array_one_ofs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyArrayOneOfArgs']]]]:
        """
        Display name and value an enum array can be set to. - 'const' - (Required) value mapping to member of 'enum'. - 'title'
        - (Required) display name for the enum value.
        """
        return pulumi.get(self, "array_one_ofs")

    @array_one_ofs.setter
    def array_one_ofs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyArrayOneOfArgs']]]]):
        pulumi.set(self, "array_one_ofs", value)

    @property
    @pulumi.getter(name="arrayType")
    def array_type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The type of the array elements if `type` is set to `array`
        """
        return pulumi.get(self, "array_type")

    @array_type.setter
    def array_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "array_type", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The description of the user schema property.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def enums(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]:
        """
        Array of values a primitive property can be set to. See `array_enum` for arrays.
        """
        return pulumi.get(self, "enums")

    @enums.setter
    def enums(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]]):
        pulumi.set(self, "enums", value)

    @property
    @pulumi.getter(name="externalName")
    def external_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        External name of the user schema property.
        """
        return pulumi.get(self, "external_name")

    @external_name.setter
    def external_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "external_name", value)

    @property
    @pulumi.getter(name="externalNamespace")
    def external_namespace(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        External namespace of the user schema property.
        """
        return pulumi.get(self, "external_namespace")

    @external_namespace.setter
    def external_namespace(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "external_namespace", value)

    @property
    @pulumi.getter
    def index(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Subschema unique string identifier
        """
        return pulumi.get(self, "index")

    @index.setter
    def index(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "index", value)

    @property
    @pulumi.getter
    def master(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Master priority for the group schema property. It can be set to `PROFILE_MASTER`, `OVERRIDE` or `OKTA`. Default:
        `PROFILE_MASTER`
        """
        return pulumi.get(self, "master")

    @master.setter
    def master(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "master", value)

    @property
    @pulumi.getter(name="masterOverridePriorities")
    def master_override_priorities(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyMasterOverridePriorityArgs']]]]:
        """
        Prioritized list of profile sources (required when `master` is `OVERRIDE`).
        """
        return pulumi.get(self, "master_override_priorities")

    @master_override_priorities.setter
    def master_override_priorities(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyMasterOverridePriorityArgs']]]]):
        pulumi.set(self, "master_override_priorities", value)

    @property
    @pulumi.getter(name="maxLength")
    def max_length(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The maximum length of the user property value. Only applies to type `string`
        """
        return pulumi.get(self, "max_length")

    @max_length.setter
    def max_length(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "max_length", value)

    @property
    @pulumi.getter(name="minLength")
    def min_length(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        The minimum length of the user property value. Only applies to type `string`
        """
        return pulumi.get(self, "min_length")

    @min_length.setter
    def min_length(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "min_length", value)

    @property
    @pulumi.getter(name="oneOfs")
    def one_ofs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyOneOfArgs']]]]:
        """
        Array of maps containing a mapping for display name to enum value. - 'const' - (Required) value mapping to member of
        'enum'. - 'title' - (Required) display name for the enum value.
        """
        return pulumi.get(self, "one_ofs")

    @one_ofs.setter
    def one_ofs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['GroupSchemaPropertyOneOfArgs']]]]):
        pulumi.set(self, "one_ofs", value)

    @property
    @pulumi.getter
    def permissions(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Access control permissions for the property. It can be set to `READ_WRITE`, `READ_ONLY`, `HIDE`. Default: `READ_ONLY`
        """
        return pulumi.get(self, "permissions")

    @permissions.setter
    def permissions(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "permissions", value)

    @property
    @pulumi.getter
    def required(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether the subschema is required
        """
        return pulumi.get(self, "required")

    @required.setter
    def required(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "required", value)

    @property
    @pulumi.getter
    def scope(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "scope")

    @scope.setter
    def scope(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "scope", value)

    @property
    @pulumi.getter
    def title(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Subschema title (display name)
        """
        return pulumi.get(self, "title")

    @title.setter
    def title(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "title", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The type of the schema property. It can be `string`, `boolean`, `number`, `integer`, `array`, or `object`
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def unique(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Whether the property should be unique. It can be set to `UNIQUE_VALIDATED` or `NOT_UNIQUE`.
        """
        return pulumi.get(self, "unique")

    @unique.setter
    def unique(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "unique", value)


@pulumi.type_token("okta:index/groupSchemaProperty:GroupSchemaProperty")
class GroupSchemaProperty(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 array_enums: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 array_one_ofs: Optional[pulumi.Input[Sequence[pulumi.Input[Union['GroupSchemaPropertyArrayOneOfArgs', 'GroupSchemaPropertyArrayOneOfArgsDict']]]]] = None,
                 array_type: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 enums: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 external_name: Optional[pulumi.Input[builtins.str]] = None,
                 external_namespace: Optional[pulumi.Input[builtins.str]] = None,
                 index: Optional[pulumi.Input[builtins.str]] = None,
                 master: Optional[pulumi.Input[builtins.str]] = None,
                 master_override_priorities: Optional[pulumi.Input[Sequence[pulumi.Input[Union['GroupSchemaPropertyMasterOverridePriorityArgs', 'GroupSchemaPropertyMasterOverridePriorityArgsDict']]]]] = None,
                 max_length: Optional[pulumi.Input[builtins.int]] = None,
                 min_length: Optional[pulumi.Input[builtins.int]] = None,
                 one_ofs: Optional[pulumi.Input[Sequence[pulumi.Input[Union['GroupSchemaPropertyOneOfArgs', 'GroupSchemaPropertyOneOfArgsDict']]]]] = None,
                 permissions: Optional[pulumi.Input[builtins.str]] = None,
                 required: Optional[pulumi.Input[builtins.bool]] = None,
                 scope: Optional[pulumi.Input[builtins.str]] = None,
                 title: Optional[pulumi.Input[builtins.str]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None,
                 unique: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        ## Example Usage

        ```python
        import pulumi
        import pulumi_okta as okta

        example = okta.GroupSchemaProperty("example",
            index="customPropertyName",
            title="customPropertyName",
            type="string",
            description="My custom property name",
            master="OKTA",
            scope="SELF")
        ```

        ## Import

        ```sh
        $ pulumi import okta:index/groupSchemaProperty:GroupSchemaProperty example <index>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] array_enums: Array of values that an array property's items can be set to.
        :param pulumi.Input[Sequence[pulumi.Input[Union['GroupSchemaPropertyArrayOneOfArgs', 'GroupSchemaPropertyArrayOneOfArgsDict']]]] array_one_ofs: Display name and value an enum array can be set to. - 'const' - (Required) value mapping to member of 'enum'. - 'title'
               - (Required) display name for the enum value.
        :param pulumi.Input[builtins.str] array_type: The type of the array elements if `type` is set to `array`
        :param pulumi.Input[builtins.str] description: The description of the user schema property.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] enums: Array of values a primitive property can be set to. See `array_enum` for arrays.
        :param pulumi.Input[builtins.str] external_name: External name of the user schema property.
        :param pulumi.Input[builtins.str] external_namespace: External namespace of the user schema property.
        :param pulumi.Input[builtins.str] index: Subschema unique string identifier
        :param pulumi.Input[builtins.str] master: Master priority for the group schema property. It can be set to `PROFILE_MASTER`, `OVERRIDE` or `OKTA`. Default:
               `PROFILE_MASTER`
        :param pulumi.Input[Sequence[pulumi.Input[Union['GroupSchemaPropertyMasterOverridePriorityArgs', 'GroupSchemaPropertyMasterOverridePriorityArgsDict']]]] master_override_priorities: Prioritized list of profile sources (required when `master` is `OVERRIDE`).
        :param pulumi.Input[builtins.int] max_length: The maximum length of the user property value. Only applies to type `string`
        :param pulumi.Input[builtins.int] min_length: The minimum length of the user property value. Only applies to type `string`
        :param pulumi.Input[Sequence[pulumi.Input[Union['GroupSchemaPropertyOneOfArgs', 'GroupSchemaPropertyOneOfArgsDict']]]] one_ofs: Array of maps containing a mapping for display name to enum value. - 'const' - (Required) value mapping to member of
               'enum'. - 'title' - (Required) display name for the enum value.
        :param pulumi.Input[builtins.str] permissions: Access control permissions for the property. It can be set to `READ_WRITE`, `READ_ONLY`, `HIDE`. Default: `READ_ONLY`
        :param pulumi.Input[builtins.bool] required: Whether the subschema is required
        :param pulumi.Input[builtins.str] title: Subschema title (display name)
        :param pulumi.Input[builtins.str] type: The type of the schema property. It can be `string`, `boolean`, `number`, `integer`, `array`, or `object`
        :param pulumi.Input[builtins.str] unique: Whether the property should be unique. It can be set to `UNIQUE_VALIDATED` or `NOT_UNIQUE`.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: GroupSchemaPropertyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        ```python
        import pulumi
        import pulumi_okta as okta

        example = okta.GroupSchemaProperty("example",
            index="customPropertyName",
            title="customPropertyName",
            type="string",
            description="My custom property name",
            master="OKTA",
            scope="SELF")
        ```

        ## Import

        ```sh
        $ pulumi import okta:index/groupSchemaProperty:GroupSchemaProperty example <index>
        ```

        :param str resource_name: The name of the resource.
        :param GroupSchemaPropertyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(GroupSchemaPropertyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 array_enums: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 array_one_ofs: Optional[pulumi.Input[Sequence[pulumi.Input[Union['GroupSchemaPropertyArrayOneOfArgs', 'GroupSchemaPropertyArrayOneOfArgsDict']]]]] = None,
                 array_type: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 enums: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
                 external_name: Optional[pulumi.Input[builtins.str]] = None,
                 external_namespace: Optional[pulumi.Input[builtins.str]] = None,
                 index: Optional[pulumi.Input[builtins.str]] = None,
                 master: Optional[pulumi.Input[builtins.str]] = None,
                 master_override_priorities: Optional[pulumi.Input[Sequence[pulumi.Input[Union['GroupSchemaPropertyMasterOverridePriorityArgs', 'GroupSchemaPropertyMasterOverridePriorityArgsDict']]]]] = None,
                 max_length: Optional[pulumi.Input[builtins.int]] = None,
                 min_length: Optional[pulumi.Input[builtins.int]] = None,
                 one_ofs: Optional[pulumi.Input[Sequence[pulumi.Input[Union['GroupSchemaPropertyOneOfArgs', 'GroupSchemaPropertyOneOfArgsDict']]]]] = None,
                 permissions: Optional[pulumi.Input[builtins.str]] = None,
                 required: Optional[pulumi.Input[builtins.bool]] = None,
                 scope: Optional[pulumi.Input[builtins.str]] = None,
                 title: Optional[pulumi.Input[builtins.str]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None,
                 unique: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = GroupSchemaPropertyArgs.__new__(GroupSchemaPropertyArgs)

            __props__.__dict__["array_enums"] = array_enums
            __props__.__dict__["array_one_ofs"] = array_one_ofs
            __props__.__dict__["array_type"] = array_type
            __props__.__dict__["description"] = description
            __props__.__dict__["enums"] = enums
            __props__.__dict__["external_name"] = external_name
            __props__.__dict__["external_namespace"] = external_namespace
            if index is None and not opts.urn:
                raise TypeError("Missing required property 'index'")
            __props__.__dict__["index"] = index
            __props__.__dict__["master"] = master
            __props__.__dict__["master_override_priorities"] = master_override_priorities
            __props__.__dict__["max_length"] = max_length
            __props__.__dict__["min_length"] = min_length
            __props__.__dict__["one_ofs"] = one_ofs
            __props__.__dict__["permissions"] = permissions
            __props__.__dict__["required"] = required
            __props__.__dict__["scope"] = scope
            if title is None and not opts.urn:
                raise TypeError("Missing required property 'title'")
            __props__.__dict__["title"] = title
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__.__dict__["type"] = type
            __props__.__dict__["unique"] = unique
        super(GroupSchemaProperty, __self__).__init__(
            'okta:index/groupSchemaProperty:GroupSchemaProperty',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            array_enums: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            array_one_ofs: Optional[pulumi.Input[Sequence[pulumi.Input[Union['GroupSchemaPropertyArrayOneOfArgs', 'GroupSchemaPropertyArrayOneOfArgsDict']]]]] = None,
            array_type: Optional[pulumi.Input[builtins.str]] = None,
            description: Optional[pulumi.Input[builtins.str]] = None,
            enums: Optional[pulumi.Input[Sequence[pulumi.Input[builtins.str]]]] = None,
            external_name: Optional[pulumi.Input[builtins.str]] = None,
            external_namespace: Optional[pulumi.Input[builtins.str]] = None,
            index: Optional[pulumi.Input[builtins.str]] = None,
            master: Optional[pulumi.Input[builtins.str]] = None,
            master_override_priorities: Optional[pulumi.Input[Sequence[pulumi.Input[Union['GroupSchemaPropertyMasterOverridePriorityArgs', 'GroupSchemaPropertyMasterOverridePriorityArgsDict']]]]] = None,
            max_length: Optional[pulumi.Input[builtins.int]] = None,
            min_length: Optional[pulumi.Input[builtins.int]] = None,
            one_ofs: Optional[pulumi.Input[Sequence[pulumi.Input[Union['GroupSchemaPropertyOneOfArgs', 'GroupSchemaPropertyOneOfArgsDict']]]]] = None,
            permissions: Optional[pulumi.Input[builtins.str]] = None,
            required: Optional[pulumi.Input[builtins.bool]] = None,
            scope: Optional[pulumi.Input[builtins.str]] = None,
            title: Optional[pulumi.Input[builtins.str]] = None,
            type: Optional[pulumi.Input[builtins.str]] = None,
            unique: Optional[pulumi.Input[builtins.str]] = None) -> 'GroupSchemaProperty':
        """
        Get an existing GroupSchemaProperty resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] array_enums: Array of values that an array property's items can be set to.
        :param pulumi.Input[Sequence[pulumi.Input[Union['GroupSchemaPropertyArrayOneOfArgs', 'GroupSchemaPropertyArrayOneOfArgsDict']]]] array_one_ofs: Display name and value an enum array can be set to. - 'const' - (Required) value mapping to member of 'enum'. - 'title'
               - (Required) display name for the enum value.
        :param pulumi.Input[builtins.str] array_type: The type of the array elements if `type` is set to `array`
        :param pulumi.Input[builtins.str] description: The description of the user schema property.
        :param pulumi.Input[Sequence[pulumi.Input[builtins.str]]] enums: Array of values a primitive property can be set to. See `array_enum` for arrays.
        :param pulumi.Input[builtins.str] external_name: External name of the user schema property.
        :param pulumi.Input[builtins.str] external_namespace: External namespace of the user schema property.
        :param pulumi.Input[builtins.str] index: Subschema unique string identifier
        :param pulumi.Input[builtins.str] master: Master priority for the group schema property. It can be set to `PROFILE_MASTER`, `OVERRIDE` or `OKTA`. Default:
               `PROFILE_MASTER`
        :param pulumi.Input[Sequence[pulumi.Input[Union['GroupSchemaPropertyMasterOverridePriorityArgs', 'GroupSchemaPropertyMasterOverridePriorityArgsDict']]]] master_override_priorities: Prioritized list of profile sources (required when `master` is `OVERRIDE`).
        :param pulumi.Input[builtins.int] max_length: The maximum length of the user property value. Only applies to type `string`
        :param pulumi.Input[builtins.int] min_length: The minimum length of the user property value. Only applies to type `string`
        :param pulumi.Input[Sequence[pulumi.Input[Union['GroupSchemaPropertyOneOfArgs', 'GroupSchemaPropertyOneOfArgsDict']]]] one_ofs: Array of maps containing a mapping for display name to enum value. - 'const' - (Required) value mapping to member of
               'enum'. - 'title' - (Required) display name for the enum value.
        :param pulumi.Input[builtins.str] permissions: Access control permissions for the property. It can be set to `READ_WRITE`, `READ_ONLY`, `HIDE`. Default: `READ_ONLY`
        :param pulumi.Input[builtins.bool] required: Whether the subschema is required
        :param pulumi.Input[builtins.str] title: Subschema title (display name)
        :param pulumi.Input[builtins.str] type: The type of the schema property. It can be `string`, `boolean`, `number`, `integer`, `array`, or `object`
        :param pulumi.Input[builtins.str] unique: Whether the property should be unique. It can be set to `UNIQUE_VALIDATED` or `NOT_UNIQUE`.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _GroupSchemaPropertyState.__new__(_GroupSchemaPropertyState)

        __props__.__dict__["array_enums"] = array_enums
        __props__.__dict__["array_one_ofs"] = array_one_ofs
        __props__.__dict__["array_type"] = array_type
        __props__.__dict__["description"] = description
        __props__.__dict__["enums"] = enums
        __props__.__dict__["external_name"] = external_name
        __props__.__dict__["external_namespace"] = external_namespace
        __props__.__dict__["index"] = index
        __props__.__dict__["master"] = master
        __props__.__dict__["master_override_priorities"] = master_override_priorities
        __props__.__dict__["max_length"] = max_length
        __props__.__dict__["min_length"] = min_length
        __props__.__dict__["one_ofs"] = one_ofs
        __props__.__dict__["permissions"] = permissions
        __props__.__dict__["required"] = required
        __props__.__dict__["scope"] = scope
        __props__.__dict__["title"] = title
        __props__.__dict__["type"] = type
        __props__.__dict__["unique"] = unique
        return GroupSchemaProperty(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="arrayEnums")
    def array_enums(self) -> pulumi.Output[Optional[Sequence[builtins.str]]]:
        """
        Array of values that an array property's items can be set to.
        """
        return pulumi.get(self, "array_enums")

    @property
    @pulumi.getter(name="arrayOneOfs")
    def array_one_ofs(self) -> pulumi.Output[Optional[Sequence['outputs.GroupSchemaPropertyArrayOneOf']]]:
        """
        Display name and value an enum array can be set to. - 'const' - (Required) value mapping to member of 'enum'. - 'title'
        - (Required) display name for the enum value.
        """
        return pulumi.get(self, "array_one_ofs")

    @property
    @pulumi.getter(name="arrayType")
    def array_type(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The type of the array elements if `type` is set to `array`
        """
        return pulumi.get(self, "array_type")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The description of the user schema property.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def enums(self) -> pulumi.Output[Optional[Sequence[builtins.str]]]:
        """
        Array of values a primitive property can be set to. See `array_enum` for arrays.
        """
        return pulumi.get(self, "enums")

    @property
    @pulumi.getter(name="externalName")
    def external_name(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        External name of the user schema property.
        """
        return pulumi.get(self, "external_name")

    @property
    @pulumi.getter(name="externalNamespace")
    def external_namespace(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        External namespace of the user schema property.
        """
        return pulumi.get(self, "external_namespace")

    @property
    @pulumi.getter
    def index(self) -> pulumi.Output[builtins.str]:
        """
        Subschema unique string identifier
        """
        return pulumi.get(self, "index")

    @property
    @pulumi.getter
    def master(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Master priority for the group schema property. It can be set to `PROFILE_MASTER`, `OVERRIDE` or `OKTA`. Default:
        `PROFILE_MASTER`
        """
        return pulumi.get(self, "master")

    @property
    @pulumi.getter(name="masterOverridePriorities")
    def master_override_priorities(self) -> pulumi.Output[Optional[Sequence['outputs.GroupSchemaPropertyMasterOverridePriority']]]:
        """
        Prioritized list of profile sources (required when `master` is `OVERRIDE`).
        """
        return pulumi.get(self, "master_override_priorities")

    @property
    @pulumi.getter(name="maxLength")
    def max_length(self) -> pulumi.Output[Optional[builtins.int]]:
        """
        The maximum length of the user property value. Only applies to type `string`
        """
        return pulumi.get(self, "max_length")

    @property
    @pulumi.getter(name="minLength")
    def min_length(self) -> pulumi.Output[Optional[builtins.int]]:
        """
        The minimum length of the user property value. Only applies to type `string`
        """
        return pulumi.get(self, "min_length")

    @property
    @pulumi.getter(name="oneOfs")
    def one_ofs(self) -> pulumi.Output[Optional[Sequence['outputs.GroupSchemaPropertyOneOf']]]:
        """
        Array of maps containing a mapping for display name to enum value. - 'const' - (Required) value mapping to member of
        'enum'. - 'title' - (Required) display name for the enum value.
        """
        return pulumi.get(self, "one_ofs")

    @property
    @pulumi.getter
    def permissions(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Access control permissions for the property. It can be set to `READ_WRITE`, `READ_ONLY`, `HIDE`. Default: `READ_ONLY`
        """
        return pulumi.get(self, "permissions")

    @property
    @pulumi.getter
    def required(self) -> pulumi.Output[Optional[builtins.bool]]:
        """
        Whether the subschema is required
        """
        return pulumi.get(self, "required")

    @property
    @pulumi.getter
    def scope(self) -> pulumi.Output[Optional[builtins.str]]:
        return pulumi.get(self, "scope")

    @property
    @pulumi.getter
    def title(self) -> pulumi.Output[builtins.str]:
        """
        Subschema title (display name)
        """
        return pulumi.get(self, "title")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        The type of the schema property. It can be `string`, `boolean`, `number`, `integer`, `array`, or `object`
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def unique(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Whether the property should be unique. It can be set to `UNIQUE_VALIDATED` or `NOT_UNIQUE`.
        """
        return pulumi.get(self, "unique")

